## seqan-raptor 2.0.0.0.git.fecfbca%2Bds

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%,dversionmangle=auto,repacksuffix=+ds" \
  https://github.com/seqan/raptor/tags (?:.*?/)?raptor-v?@ANY_VERSION@@ARCHIVE_EXT@

## seqan-raptor 2.0.0.0.git.fecfbca+ds

=== CMakeLists.txt ===
# --------------------------------------------------------------------------------------------------
# Copyright (c) 2006-2022, Knut Reinert & Freie Universität Berlin
# Copyright (c) 2016-2022, Knut Reinert & MPI für molekulare Genetik
# This file may be used, modified and/or redistributed under the terms of the 3-clause BSD-License
# shipped with this file and also available at: https://github.com/seqan/raptor/blob/main/LICENSE.md
# --------------------------------------------------------------------------------------------------

cmake_minimum_required (VERSION 3.15)

# Define the application name and version.
project (raptor VERSION 2.0.1)

# Messages
string (ASCII 27 Esc)
set (FontBold "${Esc}[1m")
set (FontReset "${Esc}[m")

# Fallback to these values if there is no git or no git repository
set (RAPTOR_COMMIT_DATE
     "2021-08-20--no-git"
     CACHE STRING
           "Set to provide a commit date if git is not available or the source directory is not a git repository."
)
set (RAPTOR_COMMIT_HASH
     "74f815358db47037e93a56b826a9df3692e55680--no-git"
     CACHE STRING
           "Set to provide a commit hash if git is not available or the source directory is not a git repository."
)

# Extract git commit hash and date
find_package (Git QUIET)

if (GIT_FOUND)
    execute_process (COMMAND "${GIT_EXECUTABLE}" -C "${CMAKE_SOURCE_DIR}" rev-parse
                     WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
                     RESULT_VARIABLE is_no_git_repository
                     ERROR_QUIET
    )

    if (NOT is_no_git_repository)
        execute_process (COMMAND "${GIT_EXECUTABLE}" describe --always --abbrev=40 --dirty
                         WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
                         OUTPUT_VARIABLE RAPTOR_COMMIT_HASH
                         ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE
        )

        execute_process (COMMAND "${GIT_EXECUTABLE}" log -1 --format=%ad --date=short
                         WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
                         OUTPUT_VARIABLE RAPTOR_COMMIT_DATE
                         ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE
        )
    endif ()
endif ()

## BUILD

# Make Release default build type
if (NOT CMAKE_BUILD_TYPE)
    set (CMAKE_BUILD_TYPE
         Release
         CACHE STRING "Choose the type of build, options are: Debug Release Coverage RelWithDebInfo MinSizeRel." FORCE
    )
endif ()

set (RAPTOR_SUBMODULES_DIR
     "${CMAKE_CURRENT_LIST_DIR}/lib"
     CACHE STRING "Directory containing submodules."
)

include (CheckCXXCompilerFlag)

set (RAPTOR_NATIVE_BUILD
     ON
     CACHE BOOL "Optimize build for current architecture."
)
if ("${CMAKE_BUILD_TYPE}" MATCHES "Debug" OR "${CMAKE_BUILD_TYPE}" MATCHES "Coverage")
    message (STATUS "${FontBold}Native build disabled due to Debug/Coverage build.${FontReset}")
elseif (RAPTOR_NATIVE_BUILD)
    message (STATUS "${FontBold}Native build enabled. Built binaries will be optimized for this system.${FontReset}")
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -march=native")
else ()
    message (STATUS "${FontBold}Native build disabled. Detecting popcnt support.${FontReset}")
    check_cxx_compiler_flag ("-mpopcnt" RAPTOR_HAS_POPCNT)
    if (RAPTOR_HAS_POPCNT)
        set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mpopcnt")
    endif ()
endif ()

check_cxx_compiler_flag ("-fopenmp" RAPTOR_HAS_OPENMP)
if (RAPTOR_HAS_OPENMP)
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fopenmp")
endif ()

check_cxx_compiler_flag ("-fopenmp-simd" RAPTOR_HAS_OPENMP_SIMD)
if (RAPTOR_HAS_OPENMP_SIMD)
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fopenmp-simd -DSIMDE_ENABLE_OPENMP")
endif ()

check_cxx_compiler_flag ("-fopenmp-simd" RAPTOR_SUPPRESS_GCC4_ABI)
if (RAPTOR_SUPPRESS_GCC4_ABI)
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-psabi")
endif ()

# Specify the directories where to store the built archives, libraries and executables
set (CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib")
set (CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib")
set (CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")

# Require compression libs.
find_package (ZLIB QUIET REQUIRED)
find_package (BZip2 QUIET REQUIRED)

# Dependency: SeqAn3.
set (SEQAN3_CEREAL
     ON
     CACHE BOOL "Require cereal to be present."
)
set (SEQAN3_SUBMODULES_DIR "${RAPTOR_SUBMODULES_DIR}")
find_package (SeqAn3 QUIET REQUIRED HINTS ${RAPTOR_SUBMODULES_DIR}/seqan3/build_system)

# Allow to include CMake scripts from seqan3.
list (APPEND CMAKE_MODULE_PATH "${SEQAN3_CLONE_DIR}/test/cmake/")
# Allow to include CMake scripts from raptor.
list (APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/cmake/")

# Define cmake configuration flags to configure and build external projects with the same flags as specified for
# this project.
set (SEQAN3_EXTERNAL_PROJECT_CMAKE_ARGS "")
list (APPEND SEQAN3_EXTERNAL_PROJECT_CMAKE_ARGS "--no-warn-unused-cli")
list (APPEND SEQAN3_EXTERNAL_PROJECT_CMAKE_ARGS "-DCMAKE_C_COMPILER=${CMAKE_C_COMPILER}")
list (APPEND SEQAN3_EXTERNAL_PROJECT_CMAKE_ARGS "-DCMAKE_C_FLAGS=${CMAKE_C_FLAGS}")
list (APPEND SEQAN3_EXTERNAL_PROJECT_CMAKE_ARGS "-DCMAKE_CXX_COMPILER=${CMAKE_CXX_COMPILER}")
list (APPEND SEQAN3_EXTERNAL_PROJECT_CMAKE_ARGS "-DCMAKE_CXX_FLAGS=${CMAKE_CXX_FLAGS} -w")
list (APPEND SEQAN3_EXTERNAL_PROJECT_CMAKE_ARGS "-DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE}")
list (APPEND SEQAN3_EXTERNAL_PROJECT_CMAKE_ARGS "-DCMAKE_INSTALL_PREFIX=${PROJECT_BINARY_DIR}")
list (APPEND SEQAN3_EXTERNAL_PROJECT_CMAKE_ARGS "-DCMAKE_VERBOSE_MAKEFILE=${CMAKE_VERBOSE_MAKEFILE}")

# Use ccache.
include (raptor_require_ccache)
raptor_require_ccache ()

# Dependency: chopper
set (RAPTOR_CHOPPER_PATH "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/libchopper_count_lib.a")
list (APPEND RAPTOR_CHOPPER_PATH "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/libchopper_layout_lib.a")

if (EXISTS "${RAPTOR_CHOPPER_PATH}")
    add_custom_target (chopper_project)
else ()
    set (RAPTOR_CHOPPER_ARGS "${SEQAN3_EXTERNAL_PROJECT_CMAKE_ARGS}")
    list (APPEND RAPTOR_CHOPPER_ARGS "-DCHOPPER_SUBMODULES_DIR=${RAPTOR_SUBMODULES_DIR}")
    list (APPEND RAPTOR_CHOPPER_ARGS "-DSEQAN3_SUBMODULES_DIR=${RAPTOR_SUBMODULES_DIR}")
    list (APPEND RAPTOR_CHOPPER_ARGS "-DCMAKE_INSTALL_LIBDIR=${CMAKE_LIBRARY_OUTPUT_DIRECTORY}")
    list (APPEND RAPTOR_CHOPPER_ARGS "-DCMAKE_INSTALL_BINDIR=${CMAKE_RUNTIME_OUTPUT_DIRECTORY}")

    include (ExternalProject)
    ExternalProject_Add (chopper_project
                         PREFIX chopper_project
                         SOURCE_DIR "${RAPTOR_SUBMODULES_DIR}/chopper"
                         DOWNLOAD_COMMAND ""
                         CMAKE_ARGS "${RAPTOR_CHOPPER_ARGS}"
                         BUILD_BYPRODUCTS "${RAPTOR_CHOPPER_PATH}"
                         UPDATE_DISCONNECTED 1
    )
endif ()

add_library (chopper_count STATIC IMPORTED)
add_dependencies (chopper_count chopper_project)
set_target_properties (chopper_count PROPERTIES IMPORTED_LOCATION
                                                "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/libchopper_count_lib.a"
)

add_library (chopper_layout STATIC IMPORTED)
add_dependencies (chopper_layout chopper_project)
set_target_properties (chopper_layout PROPERTIES IMPORTED_LOCATION
                                                 "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/libchopper_layout_lib.a"
)

add_library (chopper_lib INTERFACE IMPORTED)
set_property (TARGET chopper_lib PROPERTY INTERFACE_LINK_LIBRARIES chopper_count chopper_layout ZLIB::ZLIB BZip2::BZip2)

add_executable (chopper IMPORTED)
set_target_properties (chopper PROPERTIES IMPORTED_LOCATION
                                          "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/chopper"
)

# Add the application.
add_subdirectory (src)
message (STATUS "${FontBold}You can run `make` to build the application.${FontReset}")

## DOCUMENTATION

set (RAPTOR_BUILD_DOC
     ON
     CACHE BOOL "Build documentation"
)
if (RAPTOR_BUILD_DOC)
    add_subdirectory (doc EXCLUDE_FROM_ALL)
endif ()

## TEST

set (RAPTOR_ENABLE_BENCHMARK
     OFF
     CACHE BOOL "Compile benchmarks as cli tests."
)

set (RAPTOR_BUILD_TEST
     ON
     CACHE BOOL "Build test"
)
if (RAPTOR_BUILD_TEST)
    enable_testing ()
    add_subdirectory (test EXCLUDE_FROM_ALL)
endif ()

=== doc/CMakeLists.txt ===
# --------------------------------------------------------------------------------------------------
# Copyright (c) 2006-2022, Knut Reinert & Freie Universität Berlin
# Copyright (c) 2016-2022, Knut Reinert & MPI für molekulare Genetik
# This file may be used, modified and/or redistributed under the terms of the 3-clause BSD-License
# shipped with this file and also available at: https://github.com/seqan/raptor/blob/main/LICENSE.md
# --------------------------------------------------------------------------------------------------

cmake_minimum_required (VERSION 3.15)

# Find doxygen.
find_package (Doxygen QUIET)

if (${DOXYGEN_FOUND})
    message (STATUS "Found Doxygen: ${DOXYGEN_EXECUTABLE}")

    # Configure doxygen options.
    set (APP_TEMPLATE_DOXYFILE_IN ${CMAKE_SOURCE_DIR}/doc/doxygen_cfg)
    set (APP_TEMPLATE_DOXYGEN_OUTPUT_DIR "${PROJECT_BINARY_DIR}/doc")
    set (APP_TEMPLATE_DOXYGEN_EXCLUDE_SYMBOLS "")
    set (APP_TEMPLATE_DOXYGEN_PREDEFINED_NDEBUG "")
    set (APP_TEMPLATE_DOXYGEN_ENABLED_SECTIONS "DEV")
    set (APP_TEMPLATE_DOXYGEN_EXTRACT_PRIVATE "YES")

    configure_file (${APP_TEMPLATE_DOXYFILE_IN} ${APP_TEMPLATE_DOXYGEN_OUTPUT_DIR}/Doxyfile)
    add_custom_target (doc
                       COMMAND ${DOXYGEN_EXECUTABLE}
                       WORKING_DIRECTORY ${APP_TEMPLATE_DOXYGEN_OUTPUT_DIR}
                       COMMENT "Generating (developer) API documentation with Doxygen."
                       VERBATIM
    )
    message (STATUS "${FontBold}You can run `make doc` to build api documentation.${FontReset}")
else ()
    message (STATUS "Doxygen not found.")
endif ()

=== src/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.15)

# Shared interface
add_library ("raptor_interface" INTERFACE)
target_link_libraries ("raptor_interface" INTERFACE seqan3::seqan3 chopper_lib)
target_include_directories ("raptor_interface" INTERFACE ../include)
target_include_directories ("raptor_interface" SYSTEM INTERFACE ${RAPTOR_SUBMODULES_DIR}/chopper/include)
target_include_directories ("raptor_interface" SYSTEM INTERFACE ${RAPTOR_SUBMODULES_DIR}/robin-hood-hashing/src/include)
target_compile_options ("raptor_interface" INTERFACE "-pedantic" "-Wall" "-Wextra")
add_dependencies (raptor_interface chopper_lib)

# Raptor library
add_library ("raptor_lib" INTERFACE)
target_link_libraries ("raptor_lib" INTERFACE "raptor_argument_parsing" "raptor_build" "raptor_build_hibf"
                                              "raptor_search" "raptor_threshold" "raptor_upgrade"
)

# Raptor executable
add_executable ("raptor" raptor.cpp)
target_link_libraries ("raptor" PUBLIC "raptor_lib")

install (TARGETS raptor DESTINATION bin)
if (NOT CMAKE_VERSION VERSION_LESS 3.21) # cmake >= 3.21
    install (IMPORTED_RUNTIME_ARTIFACTS chopper DESTINATION bin)
else ()
    install (PROGRAMS "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/chopper" DESTINATION bin)
endif ()

add_subdirectory (argument_parsing)
add_subdirectory (build)
add_subdirectory (search)
add_subdirectory (threshold)
add_subdirectory (upgrade)

=== test/CMakeLists.txt ===
# --------------------------------------------------------------------------------------------------
# Copyright (c) 2006-2022, Knut Reinert & Freie Universität Berlin
# Copyright (c) 2016-2022, Knut Reinert & MPI für molekulare Genetik
# This file may be used, modified and/or redistributed under the terms of the 3-clause BSD-License
# shipped with this file and also available at: https://github.com/seqan/raptor/blob/main/LICENSE.md
# --------------------------------------------------------------------------------------------------

cmake_minimum_required (VERSION 3.15)

# Set directories for test output files, input data and binaries.
file (MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/output)
add_definitions (-DOUTPUTDIR=\"${CMAKE_CURRENT_BINARY_DIR}/output/\")
add_definitions (-DDATADIR=\"${CMAKE_CURRENT_BINARY_DIR}/data/\")
add_definitions (-DBINDIR=\"${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/\")

include (raptor_require_test)
raptor_require_test ()

# Build tests just before their execution, because they have not been built with "all" target.
# The trick is here to provide a cmake file as a directory property that executes the build command.
file (WRITE "${CMAKE_CURRENT_BINARY_DIR}/build_test_targets.cmake"
      "execute_process (COMMAND ${CMAKE_COMMAND} --build . --target api_test)\n"
      "execute_process (COMMAND ${CMAKE_COMMAND} --build . --target cli_test)\n"
      "execute_process (COMMAND ${CMAKE_COMMAND} --build ./header --target header_test)\n"
)
set_directory_properties (PROPERTIES TEST_INCLUDE_FILE "${CMAKE_CURRENT_BINARY_DIR}/build_test_targets.cmake")

# Define the test targets. All depending targets are built just before the test execution.
add_custom_target (api_test)
add_custom_target (cli_test)

# Test executables and libraries should not mix with the application files.
unset (CMAKE_ARCHIVE_OUTPUT_DIRECTORY)
unset (CMAKE_LIBRARY_OUTPUT_DIRECTORY)
unset (CMAKE_RUNTIME_OUTPUT_DIRECTORY)

# A macro that adds an api or cli test.
macro (add_app_test test_filename test_alternative)
    # Extract the test target name.
    file (RELATIVE_PATH source_file "${CMAKE_SOURCE_DIR}" "${CMAKE_CURRENT_LIST_DIR}/${test_filename}")
    get_filename_component (target "${source_file}" NAME_WE)

    # Create the test target.
    add_executable (${target} ${test_filename})
    target_link_libraries (${target} "${PROJECT_NAME}_lib" gtest gtest_main)

    # Make seqan3::test available for both cli and api tests.
    target_include_directories (${target} SYSTEM PUBLIC "${SEQAN3_CLONE_DIR}/test/include")
    target_include_directories (${target} SYSTEM PUBLIC "${SEQAN3_TEST_CLONE_DIR}/googletest/include/")

    # Add the test to its general target (cli or api).
    if (${test_alternative} STREQUAL "CLI_TEST")
        add_dependencies (${target} "${PROJECT_NAME}") # cli test needs the application executable
        add_dependencies (cli_test ${target})
        if (RAPTOR_ENABLE_BENCHMARK)
            target_include_directories (${target} SYSTEM PUBLIC "${SEQAN3_BENCHMARK_CLONE_DIR}/include/")
            target_link_libraries (${target} gbenchmark)
        endif ()
    elseif (${test_alternative} STREQUAL "API_TEST")
        add_dependencies (api_test ${target})
    endif ()

    # Generate and set the test name.
    get_filename_component (target_relative_path "${source_file}" DIRECTORY)
    if (target_relative_path)
        set (test_name "${target_relative_path}/${target}")
    else ()
        set (test_name "${target}")
    endif ()
    add_test (NAME "${test_name}" COMMAND ${target})

    unset (source_file)
    unset (target)
    unset (test_name)
endmacro ()

# A macro that adds an api test.
macro (add_api_test test_filename)
    add_app_test (${test_filename} API_TEST)
endmacro ()

# A macro that adds a cli test.
macro (add_cli_test test_filename)
    add_app_test (${test_filename} CLI_TEST)
endmacro ()

set (RAPTOR_HEADER_TEST_ONLY
     OFF
     CACHE BOOL "Only build header test."
)

if (RAPTOR_HEADER_TEST_ONLY)
    add_subdirectory (header)
else ()
    # Fetch data and add the tests.
    include (data/datasources.cmake)
    add_subdirectory (api)
    add_subdirectory (cli)
    add_subdirectory (coverage)
endif ()

if (RAPTOR_ENABLE_BENCHMARK)
    include (raptor_require_benchmark)
    raptor_require_benchmark ()
    add_subdirectory (benchmark)
endif ()

message (STATUS "${FontBold}You can run `make test` to build and run tests.${FontReset}")

=== util/CMakeLists.txt ===
# --------------------------------------------------------------------------------------------------
# Copyright (c) 2006-2022, Knut Reinert & Freie Universität Berlin
# Copyright (c) 2016-2022, Knut Reinert & MPI für molekulare Genetik
# This file may be used, modified and/or redistributed under the terms of the 3-clause BSD-License
# shipped with this file and also available at: https://github.com/seqan/raptor/blob/main/LICENSE.md
# --------------------------------------------------------------------------------------------------

cmake_minimum_required (VERSION 3.15)

# Define the application name.
project (raptor_utility)

# Make Release default build type
if (NOT CMAKE_BUILD_TYPE)
    set (CMAKE_BUILD_TYPE
         Release
         CACHE STRING "Choose the type of build, options are: Debug Release RelWithDebInfo" FORCE
    )
endif ()

include (CheckCXXCompilerFlag)

set (RAPTOR_NATIVE_BUILD
     ON
     CACHE BOOL "Optimize build for current architecture."
)
if ("${CMAKE_BUILD_TYPE}" MATCHES "Debug" OR "${CMAKE_BUILD_TYPE}" MATCHES "Coverage")
    message (STATUS "${FontBold}Native build disabled due to Debug/Coverage build.${FontReset}")
elseif (RAPTOR_NATIVE_BUILD)
    message (STATUS "${FontBold}Native build enabled. Built binaries will be optimized for this system.${FontReset}")
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -march=native")
else ()
    message (STATUS "${FontBold}Native build disabled. Detecting popcnt support.${FontReset}")
    check_cxx_compiler_flag ("-mpopcnt" RAPTOR_HAS_POPCNT)
    if (RAPTOR_HAS_POPCNT)
        set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mpopcnt")
    endif ()
endif ()

# Specify the directories where to store the built archives, libraries and executables
set (CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib")
set (CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib")
set (CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")

# Messages
string (ASCII 27 Esc)
set (FontBold "${Esc}[1m")
set (FontReset "${Esc}[m")

# Dependency: SeqAn3.
set (SEQAN3_SUBMODULES_DIR "../lib")
find_package (SeqAn3 QUIET REQUIRED HINTS ../lib/seqan3/build_system)

# Allow to include CMake scripts from seqan3.
list (APPEND CMAKE_MODULE_PATH "${SEQAN3_CLONE_DIR}/test/cmake/")

# Use ccache.
include (../cmake/raptor_require_ccache.cmake)
raptor_require_ccache ()

# Define cmake configuration flags to configure and build external projects with the same flags as specified for
# this project.
set (SEQAN3_EXTERNAL_PROJECT_CMAKE_ARGS "")
list (APPEND SEQAN3_EXTERNAL_PROJECT_CMAKE_ARGS "--no-warn-unused-cli")
list (APPEND SEQAN3_EXTERNAL_PROJECT_CMAKE_ARGS "-DCMAKE_C_COMPILER=${CMAKE_C_COMPILER}")
list (APPEND SEQAN3_EXTERNAL_PROJECT_CMAKE_ARGS "-DCMAKE_C_FLAGS=${CMAKE_C_FLAGS} -w")
list (APPEND SEQAN3_EXTERNAL_PROJECT_CMAKE_ARGS "-DCMAKE_CXX_COMPILER=${CMAKE_CXX_COMPILER}")
list (APPEND SEQAN3_EXTERNAL_PROJECT_CMAKE_ARGS "-DCMAKE_CXX_FLAGS=${CMAKE_CXX_FLAGS} -w")
list (APPEND SEQAN3_EXTERNAL_PROJECT_CMAKE_ARGS "-DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE}")
list (APPEND SEQAN3_EXTERNAL_PROJECT_CMAKE_ARGS "-DCMAKE_INSTALL_PREFIX=${PROJECT_BINARY_DIR}")
list (APPEND SEQAN3_EXTERNAL_PROJECT_CMAKE_ARGS "-DCMAKE_VERBOSE_MAKEFILE=${CMAKE_VERBOSE_MAKEFILE}")

# Optionally build mason and DREAM-Yara.
option (RAPTOR_UTILITY_BUILD_MASON "Build mason. Needed to generate artificial data set." OFF)
option (RAPTOR_UTILITY_BUILD_DREAM_YARA "Build DREAM-Yara. Needed to map reads to the NCBI RefSeq." OFF)

if (RAPTOR_UTILITY_BUILD_MASON)
    message ("-- Configuring Mason")
    include (cmake/raptor_require_mason.cmake)
    raptor_require_mason ()
    message ("-- Configuring Mason - done")
else ()
    message ("-- Mason will not be built. Enable via 'cmake -DRAPTOR_UTILITY_BUILD_MASON=1 .'")
endif ()

if (RAPTOR_UTILITY_BUILD_DREAM_YARA)
    message ("-- Configuring DREAM-Yara")
    include (cmake/raptor_require_dream_yara.cmake)
    raptor_require_dream_yara ()
    message ("-- Configuring DREAM-Yara - done")
else ()
    message ("-- DREAM-Yara will not be built. Enable via 'cmake -DRAPTOR_UTILITY_BUILD_DREAM_YARA=1 .'")
endif ()

add_library (common INTERFACE)
target_link_libraries ("common" INTERFACE seqan3::seqan3)
target_include_directories ("common" INTERFACE ../include)
target_include_directories ("common" INTERFACE ../lib/robin-hood-hashing/src/include)
target_compile_options ("common" INTERFACE "-pedantic" "-Wall" "-Wextra")

add_executable ("generate_reads" src/applications/generate_reads.cpp)
target_link_libraries ("generate_reads" "common")

add_executable ("split_sequence" src/applications/split_sequence.cpp)
target_link_libraries ("split_sequence" "common")

add_executable ("count_minimiser" ../src/argument_parsing/parse_bin_path.cpp
                                  ../src/build/hibf/parse_chopper_pack_line.cpp src/applications/count_minimiser.cpp
)
target_link_libraries ("count_minimiser" "common")

add_executable ("threshold_info"
                ../src/threshold/multiple_error_model.cpp
                ../src/threshold/one_error_model.cpp
                ../src/threshold/one_indirect_error_model.cpp
                ../src/threshold/pascal_row.cpp
                ../src/threshold/precompute_correction.cpp
                ../src/threshold/precompute_threshold.cpp
                src/applications/threshold_info.cpp
)
target_link_libraries ("threshold_info" "common")

add_executable ("apply_taxsbp" src/applications/apply_taxsbp.cpp)
target_link_libraries ("apply_taxsbp" "common")

add_executable ("generate_reads_refseq" src/applications/generate_reads_refseq.cpp)
target_link_libraries ("generate_reads_refseq" "common")

add_executable ("ibf_fpr" src/applications/ibf_fpr.cpp)
target_link_libraries ("ibf_fpr" "common")

message (STATUS "${FontBold}You can run `make install` to build the application.${FontReset}")

=== lib/chopper/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.15)

## CUSTOMISE

# Define the application name and version.
project (chopper VERSION 1.0.0)

## BUILD

# Make Release default build type
if (NOT CMAKE_BUILD_TYPE)
    set (CMAKE_BUILD_TYPE Release CACHE STRING
         "Choose the type of build, options are: Debug Release Coverage RelWithDebInfo MinSizeRel."
         FORCE)
endif ()

set (CHOPPER_SUBMODULES_DIR "${CMAKE_CURRENT_LIST_DIR}/lib" CACHE STRING "Directory containing submodules.")

# Flag checks
include (CheckCXXCompilerFlag)

check_cxx_compiler_flag ("-fopenmp" CHOPPER_HAS_OPENMP)
if (CHOPPER_HAS_OPENMP)
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fopenmp")
endif ()

check_cxx_compiler_flag ("-fopenmp-simd" CHOPPER_HAS_OPENMP_SIMD)
if (CHOPPER_HAS_OPENMP_SIMD)
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fopenmp-simd -DSIMDE_ENABLE_OPENMP")
endif ()

check_cxx_compiler_flag ("-fopenmp-simd" CHOPPER_SUPPRESS_GCC4_ABI)
if (CHOPPER_SUPPRESS_GCC4_ABI)
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-psabi")
endif ()

# Specify the directories where to store the built archives, libraries and executables
set (CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib")
set (CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib")
set (CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")
set (CMAKE_INSTALL_LIBDIR "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}" CACHE STRING "")
set (CMAKE_INSTALL_BINDIR "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}" CACHE STRING "")

# Messages
string (ASCII 27 Esc)
set (FontBold "${Esc}[1m")
set (FontReset "${Esc}[m")

# Dependency: SeqAn3.
find_package (SeqAn3 REQUIRED QUIET HINTS ${CHOPPER_SUBMODULES_DIR}/seqan3/build_system)

# Allow to include CMake scripts from seqan3.
list (APPEND CMAKE_MODULE_PATH "${SEQAN3_CLONE_DIR}/test/cmake/")
list (APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/test/cmake/")

# Define cmake configuration flags to configure and build external projects with the same flags as specified for
# this project.
set (SEQAN3_EXTERNAL_PROJECT_CMAKE_ARGS "")
list (APPEND SEQAN3_EXTERNAL_PROJECT_CMAKE_ARGS "-DCMAKE_CXX_COMPILER=${CMAKE_CXX_COMPILER}")
list (APPEND SEQAN3_EXTERNAL_PROJECT_CMAKE_ARGS "-DCMAKE_CXX_FLAGS=${CMAKE_CXX_FLAGS}")
list (APPEND SEQAN3_EXTERNAL_PROJECT_CMAKE_ARGS "-DCMAKE_C_COMPILER=${CMAKE_C_COMPILER}")
list (APPEND SEQAN3_EXTERNAL_PROJECT_CMAKE_ARGS "-DCMAKE_C_FLAGS=${CMAKE_C_FLAGS}")
list (APPEND SEQAN3_EXTERNAL_PROJECT_CMAKE_ARGS "-DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE}")
list (APPEND SEQAN3_EXTERNAL_PROJECT_CMAKE_ARGS "-DCMAKE_INSTALL_PREFIX=${PROJECT_BINARY_DIR}")
list (APPEND SEQAN3_EXTERNAL_PROJECT_CMAKE_ARGS "-DCMAKE_VERBOSE_MAKEFILE=${CMAKE_VERBOSE_MAKEFILE}")

# Dependency: xxHash
set (CHOPPER_XXHASH_PATH "${PROJECT_BINARY_DIR}/lib/libxxhash.a")

if (EXISTS "${CHOPPER_XXHASH_PATH}")
    add_custom_target (xxhash_project)
else ()
    set (CHOPPER_XXHASH_ARGS "${SEQAN3_EXTERNAL_PROJECT_CMAKE_ARGS}")
    list (APPEND CHOPPER_XXHASH_ARGS "-DXXHASH_BUILD_XXHSUM=OFF")
    list (APPEND CHOPPER_XXHASH_ARGS "-DXXHASH_BUNDLED_MODE=OFF")
    list (APPEND CHOPPER_XXHASH_ARGS "-DBUILD_SHARED_LIBS=OFF")
    list (APPEND CHOPPER_XXHASH_ARGS "--no-warn-unused-cli")

    include (ExternalProject)
    ExternalProject_Add (
        xxhash_project
        PREFIX xxhash_project
        GIT_REPOSITORY https://github.com/Cyan4973/xxHash.git
        GIT_TAG "f9155bd4c57e2270a4ffbb176485e5d713de1c9b"
        CMAKE_ARGS "${CHOPPER_XXHASH_ARGS}"
        SOURCE_SUBDIR cmake_unofficial
        BUILD_BYPRODUCTS "${CHOPPER_XXHASH_PATH}"
        UPDATE_DISCONNECTED 1
    )
endif ()

add_library (xxhash STATIC IMPORTED)
add_dependencies (xxhash xxhash_project)
set_target_properties (xxhash PROPERTIES IMPORTED_LOCATION "${CHOPPER_XXHASH_PATH}")
target_include_directories (xxhash INTERFACE "${PROJECT_BINARY_DIR}/include")

# Use ccache.
set (CHOPPER_USE_CCACHE ON CACHE BOOL "Use ccache if available.")
if (CHOPPER_USE_CCACHE)
     include (chopper_require_ccache)
     chopper_require_ccache ()
endif ()

# Add the application.
add_subdirectory (src)
message (STATUS "${FontBold}You can run `make` to build the application.${FontReset}")

## DOCUMENTATION

add_subdirectory (doc EXCLUDE_FROM_ALL)

## TEST

enable_testing ()
add_subdirectory (test EXCLUDE_FROM_ALL)

=== src/argument_parsing/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.15)

add_library ("raptor_argument_parsing" STATIC
             ../build/hibf/parse_chopper_pack_line.cpp
             build_parsing.cpp
             init_shared_meta.cpp
             parse_bin_path.cpp
             search_parsing.cpp
             upgrade_parsing.cpp
)

target_compile_definitions ("raptor_argument_parsing"
                            PUBLIC "-DRAPTOR_VERSION=\"${CMAKE_PROJECT_VERSION} (${RAPTOR_COMMIT_HASH})\""
                                   "-DRAPTOR_DATE=\"${RAPTOR_COMMIT_DATE}\""
)

target_link_libraries ("raptor_argument_parsing" PUBLIC "raptor_interface")

=== src/build/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.15)

add_library ("raptor_build" STATIC build_from_minimiser.cpp compute_minimiser.cpp raptor_build.cpp)

target_link_libraries ("raptor_build" PUBLIC "raptor_interface")

add_subdirectory (hibf)

=== src/search/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.15)

add_library ("raptor_search" STATIC
             raptor_search.cpp
             search_hibf.cpp
             search_ibf.cpp
             search_multiple.cpp
             search_socks.cpp
)

target_link_libraries ("raptor_search" PUBLIC "raptor_interface")

=== src/threshold/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.15)

add_library ("raptor_threshold" STATIC
             one_indirect_error_model.cpp
             multiple_error_model.cpp
             pascal_row.cpp
             one_error_model.cpp
             precompute_correction.cpp
             precompute_threshold.cpp
)

target_link_libraries ("raptor_threshold" PUBLIC "raptor_interface")

=== src/upgrade/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.15)

add_library ("raptor_upgrade" STATIC raptor_upgrade.cpp)
target_link_libraries ("raptor_upgrade" PUBLIC "raptor_interface")

=== test/api/CMakeLists.txt ===
# --------------------------------------------------------------------------------------------------
# Copyright (c) 2006-2022, Knut Reinert & Freie Universität Berlin
# Copyright (c) 2016-2022, Knut Reinert & MPI für molekulare Genetik
# This file may be used, modified and/or redistributed under the terms of the 3-clause BSD-License
# shipped with this file and also available at: https://github.com/seqan/raptor/blob/main/LICENSE.md
# --------------------------------------------------------------------------------------------------

cmake_minimum_required (VERSION 3.15)

add_api_test (issue_142.cpp)

=== debian/changelog ===
seqan-raptor (2.0.0.0.git.fecfbca+ds-3) unstable; urgency=medium

  * Append the CPPFLAGS, not overwrite it
  * Don't compile with -march=native
  * Revert: Upstream says doxygen docs aren't ready yet, so skip that for now.
  * Also include man page for raptor build
  * d/rules: build hardening
  * d/control: remove first-person language from the descriptions
  * d/control: -doc goes in the doc section
  * d/patches/spelling: fix a typo

 -- Michael R. Crusoe <crusoe@debian.org>  Tue, 01 Nov 2022 13:00:02 +0100

seqan-raptor (2.0.0.0.git.fecfbca+ds-2) unstable; urgency=medium

  * Generate and package the man pages.
  * Upstream says doxygen docs aren't ready yet, so skip that for now.
  * d/patches/privacy: don't phone home to check for a new version
  * d/patches/debian_xxhash: get the libdir using pkg-config (Closes:
    #1023176)

 -- Michael R. Crusoe <crusoe@debian.org>  Mon, 31 Oct 2022 11:43:26 +0100

seqan-raptor (2.0.0.0.git.fecfbca+ds-1) unstable; urgency=medium

  * Initial release (Closes: #1022057)

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 19 Oct 2022 18:58:32 +0200

=== debian/control ===
Source: seqan-raptor
Section: science
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Michael R. Crusoe <crusoe@debian.org>
Build-Depends: debhelper-compat (= 13),
               cmake,
               libseqan3-dev (>= 3.2.0+ds-5),
               libgtest-dev,
               libxxhash-dev,
               libcereal-dev,
               libsimde-dev,
               pkg-config,
               doxygen <!nodoc>,
               texlive-font-utils <!nodoc>,
               texlive-latex-base <!nodoc>,
               texlive-latex-recommended <!nodoc>,
               texlive-latex-extra <!nodoc>,
               texlive-plain-generic <!nodoc>,
               texlive-fonts-recommended <!nodoc>,
               ghostscript <!nodoc>
Standards-Version: 4.6.1
Vcs-Browser: https://salsa.debian.org/med-team/seqan-raptor
Vcs-Git: https://salsa.debian.org/med-team/seqan-raptor.git
Homepage: https://github.com/seqan/raptor
Rules-Requires-Root: no

Package: seqan-raptor
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: pre-filter for querying very large collections of nucleotide sequences
 Raptor is a system for approximately searching many queries such as
 next-generation sequencing reads or transcripts in large collections of
 nucleotide sequences. Raptor uses winnowing minimizers to define a set of
 representative k-mers, an extension of the interleaved Bloom filters (IBFs) as
 a set membership data structure and probabilistic thresholding for minimizers.
 This approach allows compression and partitioning of the IBF to enable the
 effective use of secondary memory.

Package: seqan-raptor-doc
Architecture: all
Depends: ${misc:Depends}
Section: doc
Description: HTML & PDF documentation for seqan-raptor and its APIs
 Raptor is a system for approximately searching many queries such as
 next-generation sequencing reads or transcripts in large collections of
 nucleotide sequences. Raptor uses winnowing minimizers to define a set of
 representative k-mers, an extension of the interleaved Bloom filters (IBFs) as
 a set membership data structure and probabilistic thresholding for minimizers.
 This approach allows compression and partitioning of the IBF to enable the
 effective use of secondary memory.
 .
 This package contains Raptor's docs (HTML & PDF).

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1
export LC_ALL=C.UTF-8
export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export DEB_CPPFLAGS_MAINT_APPEND=-I/usr/include/seqan3/submodules/sdsl-lite/include/ -I/usr/include/simde -I${CURDIR}/lib/submodules/sharg-parser/include/ -I${CURDIR}/lib/submodules/lemon/include/
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DRAPTOR_NATIVE_BUILD=OFF

override_dh_auto_build-arch:
	dh_auto_build --arch
	obj-*/bin/raptor --export-help man > debian/raptor.1
	obj-*/bin/raptor build --export-help man > debian/raptor-build.1
	obj-*/bin/raptor search --export-help man > debian/raptor-search.1
	obj-*/bin/raptor socks --export-help man > debian/raptor-socks.1
	obj-*/bin/raptor socks build --export-help man > debian/raptor-socks-build.1
	obj-*/bin/raptor socks lookup-kmer --export-help man > debian/raptor-socks-lookup-kmer.1
	obj-*/bin/raptor upgrade --export-help man > debian/raptor-upgrade.1

override_dh_auto_build-indep:
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS) $(DEB_BUILD_PROFILES)))
	cd obj-* && $(MAKE) doc && cd doc/latex && $(MAKE)
endif

### When overriding auto_test make sure DEB_BUILD_OPTIONS will be respected
#override_dh_auto_test:
#ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
#	do_stuff_for_testing
#endif
